Index: XIOS3/trunk/src/transport/legacy_context_server.cpp
===================================================================
--- XIOS3/trunk/src/transport/legacy_context_server.cpp	(revision 2498)
+++ XIOS3/trunk/src/transport/legacy_context_server.cpp	(revision 2507)
@@ -323,4 +323,5 @@
         {
           eventScheduler_->registerEvent(currentTimeLine,hashId);
+          info(100)<<"Context id "<<context->getId()<<"Schedule event : "<< currentTimeLine <<"  "<<hashId<<endl ;
           scheduled=true;
         }
@@ -342,4 +343,22 @@
             if (!flag) return ;
             eventScheduled_=false ;
+          }
+          
+          if (CXios::checkEventSync)
+          {
+            int typeId, classId, typeId_in, classId_in;
+            long long timeLine_out;
+            long long timeLine_in( currentTimeLine );
+            typeId_in=event->type ;
+            classId_in=event->classId ;
+   //        MPI_Allreduce(&timeLine,&timeLine_out, 1, MPI_UINT64_T, MPI_SUM, intraComm) ; // MPI_UINT64_T standardized by MPI 3
+            MPI_Allreduce(&timeLine_in,&timeLine_out, 1, MPI_LONG_LONG_INT, MPI_SUM, intraComm) ; 
+            MPI_Allreduce(&typeId_in,&typeId, 1, MPI_INT, MPI_SUM, intraComm) ;
+            MPI_Allreduce(&classId_in,&classId, 1, MPI_INT, MPI_SUM, intraComm) ;
+            if (typeId/intraCommSize!=event->type || classId/intraCommSize!=event->classId || timeLine_out/intraCommSize!=currentTimeLine)
+            {
+               ERROR("void CLegacyContextClient::sendEvent(CEventClient& event)",
+                  << "Event are not coherent between client for timeline = "<<currentTimeLine);
+            }
           }
 
Index: XIOS3/trunk/src/transport/one_sided_context_client.hpp
===================================================================
--- XIOS3/trunk/src/transport/one_sided_context_client.hpp	(revision 2498)
+++ XIOS3/trunk/src/transport/one_sided_context_client.hpp	(revision 2507)
@@ -30,4 +30,5 @@
       COneSidedContextClient(CContext* parent, MPI_Comm intraComm, MPI_Comm interComm, CContext* parentServer = 0);
 
+      ETransport getType(void) {return oneSided ;}
       // Send event to server
       void sendEvent(CEventClient& event);
Index: XIOS3/trunk/src/transport/online_context_client.hpp
===================================================================
--- XIOS3/trunk/src/transport/online_context_client.hpp	(revision 2507)
+++ XIOS3/trunk/src/transport/online_context_client.hpp	(revision 2507)
@@ -0,0 +1,52 @@
+#ifndef __ONLINE_CONTEXT_CLIENT_HPP__
+#define __ONLINE_CONTEXT_CLIENT_HPP__
+
+#include "xios_spl.hpp"
+#include "buffer_out.hpp"
+#include "buffer_in.hpp"
+#include "buffer_client.hpp"
+#include "event_client.hpp"
+#include "event_server.hpp"
+#include "mpi.hpp"
+#include "registry.hpp"
+#include "context_client.hpp"
+
+namespace xios
+{
+  class CContext;
+  class CContextServer ;
+  /*!
+  \class CLegacyContextClient
+  A context can be both on client and on server side. In order to differenciate the role of
+  context on each side, e.x client sending events, server receiving and processing events, there is a need of
+  concrete "context" classes for both sides.
+  CLegacyContextClient processes and sends events from client to server where CContextServer receives these events
+  and processes them.
+  */
+  class COnlineContextClient : public CContextClient
+  {
+    public:
+      // Contructor
+      COnlineContextClient(CContext* parent, MPI_Comm intraComm, MPI_Comm interComm, CContext* parentServer = 0):
+                          CContextClient(parent, intraComm, interComm, parentServer) {}
+
+      // Send event to server
+      ETransport getType(void) { return online ;}
+      
+      void sendEvent(CEventClient& event) { ERROR("void COnlineContextClient::sendEvent(CEventClient& event)",<< "this method may not be called") ;}
+      void eventLoop(void) { ERROR("void COnlineContextClient::eventLoop(void)",<< "this method may not be called") ;}
+      void releaseBuffers(void) { ERROR("void COnlineContextClient::releaseBuffers(void)",<< "this method may not be called") ;}
+      bool havePendingRequests(void) { ERROR(" bool COnlineContextClient::havePendingRequests(void)",<< "this method may not be called") ; return false ;}
+
+      bool isNotifiedFinalized(void) { ERROR("bool COnlineContextClient::isNotifiedFinalized(void)",<< "this method may not be called") ;return false ;}
+      void finalize(void) { ERROR("void COnlineContextClient::finalize(void)",<< "this method may not be called") ;}
+
+      void setBufferSize(const std::map<int,StdSize>& mapSize) { ERROR("void setBufferSize(const std::map<int,StdSize>& mapSize)",<< "this method may not be called") ;}
+
+
+    private:
+
+  };
+}
+
+#endif // __Online_CONTEXT_CLIENT_HPP__
Index: XIOS3/trunk/src/type/type_util.hpp
===================================================================
--- XIOS3/trunk/src/type/type_util.hpp	(revision 2498)
+++ XIOS3/trunk/src/type/type_util.hpp	(revision 2507)
@@ -70,5 +70,11 @@
     class CServiceNode ;
     class CServiceNodeGroup ;
-      
+    class CRedistributeDomain;
+    class CRedistributeDomainGroup;
+    class CRedistributeAxis;
+    class CRedistributeAxisGroup;
+    class CRedistributeScalar;
+    class CRedistributeScalarGroup;
+       
   template <typename T> inline string getStrType(void);
 
@@ -158,5 +164,11 @@
   macro(CServiceNode)
   macro(CServiceNodeGroup)
-  
+  macro(CRedistributeDomain)
+  macro(CRedistributeDomainGroup)  
+  macro(CRedistributeAxis)
+  macro(CRedistributeAxisGroup)  
+  macro(CRedistributeScalar)
+  macro(CRedistributeScalarGroup)  
+
 #undef macro
 }
Index: XIOS3/trunk/src/xml_parser_decl.cpp
===================================================================
--- XIOS3/trunk/src/xml_parser_decl.cpp	(revision 2498)
+++ XIOS3/trunk/src/xml_parser_decl.cpp	(revision 2507)
@@ -44,4 +44,8 @@
     macro( PoolNode )
     macro( ServiceNode )
+    macro( RedistributeDomain )
+    macro( RedistributeAxis )
+    macro( RedistributeScalar )
+
   }
 }
